# Publications

##### Original Paper
::: indent
[OCCA: A unified approach to multi-threading languages](https://arxiv.org/abs/1403.0968)

<div class="authors">
  <a href="http://dsmedina.com" target="_blank">David Medina</a>,
  <a href="https://scholar.google.com/citations?user=JFap1psAAAAJ&hl=en&oi=sra" target="_blank">Amik St-Cyr</a>,
  <a href="https://www.paranumal.com" target="_blank">Tim Warburton</a>
</div>

```bibtex
@article{medina2014occa,
  title={OCCA: A unified approach to multi-threading languages},
  author={Medina, David S and St-Cyr, Amik and Warburton, Tim},
  journal={arXiv preprint arXiv:1403.0968},
  year={2014}
}
```
:::

---

If you have a paper that used OCCA and would like to add it, feel free to
- Submit a [merge request](https://github.com/libocca/libocca.org)
- Create an [issue](https://github.com/libocca/libocca.org/issues) with your paper information
- Send a friendly email to one of the [team members](/team) :)

---

##### 2020

::: indent

[Portable high-order finite element kernels I: Streaming Operations](https://arxiv.org/abs/2009.10917)

[GPU-Accelerated Discontinuous Galerkin Methods: 30x Speedup on 345 Billion Unknowns](https://arxiv.org/abs/2006.15698)

[Optimization of Tensor-product Operations in Nekbone on GPUs](https://arxiv.org/abs/2005.13425)

:::

##### 2019

::: indent

[A GPU-accelerated continuous and discontinuous Galerkin non-hydrostatic atmospheric model](https://journals.sagepub.com/doi/full/10.1177/1094342017694427)

:::

##### 2018
::: indent

[Discontinuous Galerkin Discretizations of the Boltzmann Equations in 2D: semi-analytic time stepping and absorbing boundary layers](https://arxiv.org/abs/1805.02082v1)

[Hermite Methods for the Scalar Wave Equation](https://arxiv.org/abs/1802.05246)

[An entropy stable discontinuous Galerkin method for the shallow water equations on curvilinear meshes with wet/dry fronts accelerated by GPUs](https://arxiv.org/abs/1804.02221)

[GPU Acceleration of a High-Order Discontinuous Galerkin Incompressible Flow Solver](https://arxiv.org/abs/1801.00246)

:::

##### 2017
::: indent

[Acceleration of tensor-product operations for high-order finite element methods](https://arxiv.org/abs/1711.00903)

[A GPU-accelerated nodal discontinuous Galerkin method with high-order absorbing boundary conditions and corner/edge compatibility](https://arxiv.org/abs/1610.05023)

[GPU Acceleration of Hermite Methods for the Simulation of Wave Propagation](https://link.springer.com/chapter/10.1007%2F978-3-319-65870-4_25)

[GPU-accelerated Bernstein-Bezier discontinuous Galerkin methods for wave problems](https://arxiv.org/abs/1512.06025)

[Acceleration of the Implicit-Explicit Non-hydrostatic Unified Model of the Atmosphere (NUMA) on Manycore Processors](https://arxiv.org/abs/1702.04316)

[A GPU-accelerated continuous and discontinuous Galerkin non-hydrostatic atmospheric model](http://journals.sagepub.com/doi/abs/10.1177/1094342017694427)

:::

##### 2016
::: indent

[GPU-accelerated discontinuous Galerkin methods on hybrid meshes](https://arxiv.org/abs/1507.02557)

[A GPU accelerated level set reinitialization for an adaptive discontinuous Galerkin method](https://www.sciencedirect.com/science/article/pii/S0898122116302930)

[Orthogonal bases for vertex-mapped pyramids](https://arxiv.org/abs/1502.07703)

[A GPU-accelerated adaptive discontinuous Galerkin method for level set equation](https://www.tandfonline.com/doi/abs/10.1080/10618562.2016.1155704)

[GPU performance analysis of a nodal discontinuous Galerkin method for acoustic and elastic models](https://arxiv.org/abs/1602.07997)

:::

##### 2015
::: indent

[A nodal discontinuous Galerkin method for reverse-time migration on GPU clusters](https://arxiv.org/abs/1506.00907)

[A Model Evaluation Study for Treatment Planning of Laser Induced Thermal Therapy](https://www.ncbi.nlm.nih.gov/pmc/articles/PMC4904296/)

[GPU Accelerated Discontinuous Galerkin Methods for Shallow Water Equations](https://arxiv.org/abs/1403.1661)

[GPU accelerated spectral finite elements on all-hex meshes](https://arxiv.org/abs/1506.05996)

[Higgs Boson equation in de Sitter spacetime: Numerical investigation of bubbles using GPUs](https://search.proquest.com/openview/0ce477b9a1a6a0703eafc9d05bf22030/1?pq-origsite=gscholar&cbl=18750&diss=y)

[OKL: A Unified Language for Parallel Architectures](https://scholarship.rice.edu/bitstream/handle/1911/88213/MEDINA-DOCUMENT-2015.pdf?sequence=1)

[Portability and Performance of Nuclear Reactor Simulations on Many-Core Architectures](https://dl.acm.org/citation.cfm?id=2820092)

:::

##### 2014
::: indent
[brainNek: Modeling Laser-Induced Thermal Therapy for Brain Cancer with Spectral Elements on GPUs](https://web.stanford.edu/~tym1/materials/moon_bs_thesis.pdf)

[OCCA: A Unified Approach for Multi-Threading Languages](https://scholarship.rice.edu/bitstream/handle/1911/88205/MEDINA-DOCUMENT-2014.pdf?sequence=1)
:::
